vocabulary dos
dos definitions
hex

: #8    8  device#  !  ;
: #9    9  device#  !  ;

( Return the LFN of the command channel for a device, opening a new file if )
( necessary )
: cmd-lfn   ( d#  --  lfn )
    0  98  c@  0  ?do
	over  263  i  +  c@  =  if
	    26d  i  +  c@  1f  and  0f  =  if
		drop  259  i  +  c@
	    then  then  loop
    ?dup  0=  if
	0  0  $setnam  0f  swap  dup  next-lfn  dup
	>r  $setlfs  $open  r>  swap  if  drop  0  then
    else  nip  then  ;

( Read one directory entry into PAD, first byte contains the length of the )
( variable part )
: read-dir-rec   (  --  )
    0  pad  c!  pad  1+  4  $read  0=  swap  4  =  and  if
	pad  4  +  begin
	    1+  dup  1  $read  swap  drop  dup  0=  if
		pad  c@  1+  pad  c!  over  c@  0=  or  then
	until  drop
    then  ;

( Read from LFN and print each directory entry )
: print-dir   ( lfh  --  )
    $chkin ?dup if
	." error setting input " . drop
    else  pad  2  $read  2drop   ( skip start addr )
	begin
	    read-dir-rec  pad  c@  dup  if
		cr  pad  3  +  @  .  pad  5  +  swap  type
		?terminal  not  then  0=
	until  cr $rstin
    then  ;

( Print the directory of the default drive of the default device )
: $   (  --  )
    pad  2  over  c!  1+  [char] $  over  c!  1+  drive#  @  [char] 0  +  swap  c!
    pad  count  0  open-file  ?dup  if
	." disk error "  .  drop
    else  dup  print-dir  close-file  then  ;

( Execute a DOS command on the default device, return the result )
: dos-cmd   ( addr count  --  addr count )
    device#  @  cmd-lfn  >r  ?dup  if
	r@  write-line  drop  else
	drop  then
    pad  20  r>  read-line  drop  pad  count  ;

( Print the error status of the default device )
: @.
    0  0  dos-cmd  type  ;

( Execute a DOS command and print the error status )
: @"
    22  word  dos-cmd  type  ;

forth definitions
decimal
